/* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenC1_testdrv.c,v
   Comment: Tiny driver used for code generation and testing of CGC1
   Release: scope-0-10 

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   CodGenC1_testdrv.c,v 1.14 2002/10/24 20:17:10 wasowski Exp
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/* defined in CodGenC1.c in DEBUG mode */

extern void dump_conf(void); 
extern void next_conf_reset(void);
extern const char * evdict[];

/*
 * This function is basically an interpreter for a small test language
 * the syntax is as follows
 *
 * cmd -> init | conf | macro e | quit
 *
 * where
 *
 * init, conf, macro and quit are kewywords and e is an event name.
 * semantics:
 *
 * init - initialize the model
 * conf - print current configuration on stdout (no changes to the model)
 * quit - exit the program
 * macro e - make e a current event and start a macrostep. 
 * autoconf - enters autoconf mode. In this mode configuration is printed
 *            automatically after processing of each command.
 */
int main(void) {

	int autoconf = 0;

	/* unsafe but this is only a test program */
	char buf[400];
	int i;

	while (1) {

		if (scanf( "%s", buf )==EOF) 
			exit(EXIT_FAILURE);

		else if ( strcmp( buf, "autoconf" ) == 0 )
			autoconf = 1;

		else if ( strcmp( buf, "quit" ) == 0 )  
			exit(EXIT_SUCCESS);

		else if ( strcmp( buf, "conf" ) == 0 ) {
			if (!autoconf)
				dump_conf();

		} else if ( strcmp( buf, "init" ) == 0 ) {
			next_conf_reset();
			st_init();

		} else if (strcmp ( buf, "macro" ) == 0 ) {

			if (scanf ( "%s", buf ) == EOF)
				exit (EXIT_SUCCESS);
			
			for (i = 0; i < EVENTNO; i++) {
				if (strcmp(evdict[i],buf) == 0) {
					CurrEvent.tag = i;
					macrostep();
					break;
				}
			}
			if ( i == EVENTNO ) {
				
				fprintf(stderr, "Unknown event.\n");
				exit (EXIT_FAILURE);
			}

		} else {

			fprintf (stderr, "Syntax error.\n");
			exit(EXIT_FAILURE);
		}
		if (autoconf) dump_conf();
	}

	return 0;
}

